// Generated by CoffeeScript 1.8.0
(function() {
  var Context, F, assert, async, call, colors, empty, hoist, include, isGeneratorFunction, isPromise, isType, lift, promise, report;

  if (global.$p == null) {
    global.$p = function() {
      return console.log.apply(console, arguments);
    };
  }

  assert = require("assert");

  colors = require("colors");

  F = require("fairmont");

  empty = F.empty, include = F.include;

  isType = F.isType, isPromise = F.isPromise, isGeneratorFunction = F.isGeneratorFunction;

  promise = F.promise, lift = F.lift, async = F.async, call = F.call;

  hoist = function(f) {
    if (isGeneratorFunction(f)) {
      return async(f);
    } else {
      return f;
    }
  };

  Context = {
    create: function(description, parent) {
      var context;
      context = {
        description: description,
        parent: parent,
        kids: [],
        root: parent.root
      };
      return include(context, {
        test: function(description, f) {
          var child, g;
          parent = context;
          child = Context.create(description, parent);
          parent.kids.push(child);
          if ((g = hoist(f)) != null) {
            child.start();
            return call(function*() {
              var error;
              try {
                (yield g(child));
                return child.pass();
              } catch (_error) {
                error = _error;
                return child.fail(error);
              }
            });
          }
        },
        describe: function() {
          return context.test.apply(context, arguments);
        },
        pass: function() {
          context.finish();
          return context.result = true;
        },
        fail: function(error) {
          context.finish();
          context.result = false;
          if (error != null) {
            context.error = error;
            if (!isType(assert.AssertionError, error)) {
              return context.root.errors.push(error);
            }
          }
        },
        start: context.root.start,
        finish: context.root.finish
      });
    },
    describe: function(description, f) {
      return promise(function(resolve, reject) {
        var error, pending, root;
        try {
          pending = 0;
          root = {
            start: function() {
              return ++pending;
            },
            finish: function() {
              return setImmediate(function() {
                if (--pending === 0) {
                  resolve();
                  return report(root);
                }
              });
            },
            errors: []
          };
          root.context = Context.create(description, {
            root: root
          });
          return f(root.context);
        } catch (_error) {
          error = _error;
          console.error(error.stack);
          return report(root);
        }
      });
    }
  };

  report = function(_arg) {
    var context, errors, _report;
    context = _arg.context, errors = _arg.errors;
    (_report = function(context, indent) {
      var description, error, kid, kids, parent, result, root, _i, _len, _results;
      description = context.description, result = context.result, error = context.error, parent = context.parent, root = context.root, kids = context.kids;
      console.log(indent, result != null ? result ? description.green : error != null ? ("" + description + " " + error).red : description.red : empty(kids) ? description.yellow : description.green);
      indent += "  ";
      _results = [];
      for (_i = 0, _len = kids.length; _i < _len; _i++) {
        kid = kids[_i];
        _results.push(_report(kid, indent));
      }
      return _results;
    })(context, "");
    return setImmediate(function() {
      var error, _i, _len, _results;
      _results = [];
      for (_i = 0, _len = errors.length; _i < _len; _i++) {
        error = errors[_i];
        _results.push(console.error("\n" + error.stack));
      }
      return _results;
    });
  };

  module.exports = Context;

}).call(this);
